unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.Grids, system.UITypes,
  Vcl.ExtCtrls;

type
  darray = array of array of extended;
  sarray = array of extended;
  iarray = array of integer;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    LabeledEdit1: TLabeledEdit;
    BitBtn2: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    CheckBox1: TCheckBox;
    RadioGroup1: TRadioGroup;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure GridSet(Sin, Colin: integer);    // ObhTCYύX
    function gauss(n: integer; var a: darray; var b, x: sarray): extended;
    function lu(n: integer; var a: darray; var ip: iarray): extended;
    procedure solve(n : integer; var a: darray; var b, x: sarray; var ip: iarray);
    procedure testset;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  Nltest : integer = 4;             // eXgf[^[s
                                    // eXgf[^[
  mattestA : array[0..3] of array[0..3] of extended = ((8, 16, 24, 32),
                                                       (2,  7, 12, 17),
                                                       (6, 17, 32, 59),
                                                       (7, 22, 46,105));
  mattestB : array[0..3] of array[0..3] of extended = ((8, 16, 24,  32),
                                                       (2,  7, 12,  17),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestC : array[0..3] of array[0..3] of extended = ((8,  34, 24, 32),
                                                       ( 2,  7,  0, 0),
                                                       (24, 17,  0, 0),
                                                       ( 7,  0,  0, 0));
  mattestD : array[0..3] of array[0..3] of extended = ((8,  16, 24,  0),
                                                       (2,  7, 12,   0),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestE : array[0..3] of array[0..3] of extended = ((0,  0,  0,  32),
                                                       (0,  0, 12,  17),
                                                       (6, 17, 32,   0),
                                                       (7,  0,  0, 105));
  btestA    : array[0..3] of extended = (160, 70, 198, 291);
  btestB    : array[0..3] of extended = (150, 60, 10, 40);
  Nl : integer;                           // s
  matA, Asave : darray; // Asz
  b, x : sarray;
  epsilon : extended;

// Obh̐ݒ
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W, i:integer;                                // ȏ̓XN[
begin
  inc(Sin);
  inc(Colin);
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      StringGrid2.ScrollBars := ssNone;           // XN[o[\
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      StringGrid2.ScrollBars := ssVertical;       // XN[o[\
    end;
  if Colin <= 11 then                             // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * Colin;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * (10 + 1);
      StringGrid1.ScrollBars := ssBoth;           // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
  for i := 1 to Sin - 1 do StringGrid1.Cells[0,i] := 'a' + intTostr(i) + '*';
  for i := 1 to Sin - 1 do StringGrid1.Cells[i,0] := 'a*' + intTostr(i);
  StringGrid2.RowCount := Sin;
  StringGrid2.ClientHeight := H + 1;
  StringGrid2.ClientWidth := (StringGrid2.DefaultColWidth + 1) * 2;
  for i := 1 to Sin - 1 do StringGrid2.Cells[0, i] := intTostr(i);
  StringGrid2.Cells[1, 0] := 'b*=';
end;

// lu
// n s
// a s̒l
// ip s
// ߂l s̒l
function TForm1.lu(n: integer; var a: darray; var ip: iarray): extended;
var
  i, j, k, ii, ik: integer;
  t, u : extended;
  weight : sarray;
begin
  setlength(weight, n);
  result := 1;                        //  <> 0   0 s
  j := 0;
  for k := 0 to n - 1 do begin        // es d݌vZ
    u := 0;                           // ̍s̐Βlő̗vf߂
    for j := 0 to n - 1 do begin
      t := abs(a[k, j]);
      if t > u then u := t;           // ől
    end;
    j := 0;
    if u = 0 then exit;               // ől0 ȂsLUłȂ 񂪑Să[
    weight[k] := 1 / u;               // ől̋t
  end;
  for k := 0 to n - 1 do begin        //
    u := -1;
    for i := k to n - 1 do begin      // k̍s
      ii := ip[i];                    // d݁~Βl ő̍s
      t := abs(a[ii, k]) * weight[ii];
      if t > u then begin
        u := t;
        j := i;                       // j ő̍s
      end;
    end;
    ik := ip[j];
    if j <> k then begin              // słȂs
      ip[j] := ip[k];
      ip[k] := ik;
      result := -result;
    end;
    u := a[ik, k];                    // Ίp sւĂ̂ik<>k
    if u = 0 then begin
      result := 0;
      exit;                           // ΊpɃ[LvZoȂ̂ŏI
    end;
    result := result * u;
    for i := k + 1 to n - 1 do begin  // KEX̏@
      ii := ip[i];
      a[ii, k] := a[ii, k] / u;       // L
      t := a[ii, k];
      for j := k + 1 to n - 1 do a[ii, j] := a[ii, j] - t * a[ik, j];  // U
      j := 0;
    end;
  end;
end;

// LUgpĘA
procedure TForm1.solve(n : integer; var a: darray; var b, x: sarray; var ip: iarray);
var
  i, j, ii: integer;
  t : extended;
begin
  for i := 0 to n - 1 do begin        // KEX̏@̎c Oi
    ii := ip[i];
    t := b[ii];
    for j := 0 to i - 1 do t := t - a[ii, j] * x[j];
    x[i] := t;
  end;
  for i := n - 1 downto 0 do begin    // ޑ
    t := x[i];
    ii := ip[i];
    for j := i + 1 to n - 1 do t := t - a[ii, j] * x[j];
    x[i] := t / a[ii, i];
  end;
end;

// KEX@
function TForm1.gauss(n: integer; var a: darray; var b, x: sarray): extended;
var
  ip : iarray;
  det : extended;
  i : integer;
  LL : string;
begin
  setlength(ip, n);

  for i := 0 to n - 1 do ip[i] := i;                      // sNo

  det := lu(n, a, ip);                                    // LU

  if det = 0 then
    MessageDlg('ΊpɃ[vZo܂B', mtInformation,[mbOk], 0);

  if det <> 0 then begin            // LUo
    solve(n, a, b, x, ip);            // LUgpĘA
    LL := 'vZ  ';
    for i := 0 to n - 2 do begin
      LL := LL + inttostr(ip[i] + 1) + ', ';
    end;
    LL := LL + inttostr(ip[n -1] + 1);
    memo1.Lines.Append(LL);
  end;
  result := det;                              // ߂l <> 0  0 s
end;

// vZƌZ
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, j, ch: integer;
  det, aer : extended;
  y : sarray;
  allowable_errorr : extended;
  maxb, minb, bc : extended;
  acmax : sarray;
  acmin : sarray;
begin
  setlength(matA, Nl, Nl);
  setlength(Asave, Nl, Nl);
  setlength(b, Nl);
  setlength(x, Nl);
  setlength(y, Nl);
  setlength(acmax, Nl);
  setlength(acmin, Nl);
  // matAɃObh1lǂݍ
  for i := 0 to Nl - 1 do
    for j := 0 to Nl - 1 do begin
      val(StringGrid1.Cells[i + 1,j + 1], matA[j,i], ch);
      if ch <> 0 then begin
        MessageDlg('a' + intTostr(j + 1) + ',' + intTostr(i + 1) + ' ̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
        exit;
      end;
    end;
  for i := 0 to Nl - 1 do                               // matA Asaveɕۑ
    for j := 0 to Nl - 1 do Asave[i, j] := matA[i, j];
  // bɃObh2lǂݍ
  for i := 0 to Nl - 1 do begin
    val(StringGrid2.Cells[1, i + 1], b[i], ch);
    if ch <> 0 then begin
      MessageDlg('b' + intTostr(i + 1) + '̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
      exit;
    end;
  end;
  // Ze덷
  val(labelededit2.Text, allowable_errorr, ch);
  if ch <> 0 then begin
    MessageDlg('Z덷el̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  // As̍őlŏl
  for i := 0 to Nl -1 do begin
    acmax[i] := 1;
    acmin[i] := 1;
    if matA[i, 0] <> 0 then acmax[i] := abs(matA[i, 0]);
    if matA[i, 0] <> 0 then acmin[i] := abs(matA[i, 0]);
    for j := 1 to Nl - 1 do begin
      if (abs(matA[i, j]) > acmax[i]) and (matA[i, j] <> 0) then acmax[i] := abs(matA[i, j]);
      if (abs(matA[i, j]) < acmin[i]) and (matA[i, j] <> 0) then acmin[i] := abs(matA[i, j]);
    end;
  end;
  // BsAs̔ŏlƍől
  maxb := abs(b[0]) / acmax[0];
  minb := abs(b[0]) / acmin[0];
  for i := 1 to Nl - 1 do begin
    if abs(b[i]) / acmax[i] > maxb then maxb := abs(b[i]) / acmax[i];
    if abs(b[i]) / acmin[i] < minb then minb := abs(b[i]) / acmin[i];
  end;
  // b̒l͈̔͂Z͈̔͂zĂ邩
  bc := minb;
  if (minb = 0) and (maxb > 0) then
    if maxb >= 1 then bc := 1 / maxb
                 else bc := maxb;
  if (minb > 0) and (maxb > 0) then bc := minb / maxb;
  if (minb = 0) and (maxb = 0) then bc := 1;
  if checkbox1.Checked = false then
    if bc  < epsilon then begin
      MessageDlg('b̓͒l̒lZ͈̔͂𒴂Ă܂B', mtInformation,[mbOk], 0);
      memo1.Clear;
      exit;
    end;
  // Zʂ̔lݒ
  allowable_errorr := allowable_errorr * sqrt(bc);

  memo1.Clear;

  det := gauss(Nl, matA, b, x);                         // Gausas  Axn = b ŉ det s񎮂̒l

  if det = 0 then exit;
  memo1.Lines.Append('s񎮂̒l ' + floatTostr(det));

  // Z̕\
  memo1.Lines.Append('sNo          ');
  for i := 0 to Nl - 1 do begin
    aer := 0;
    for j := 0 to Nl - 1 do begin
      aer := aer + Asave[i, j] * x[j];
    end;
    y[i] := b[i] - aer;
    memo1.Lines.Append('No' + intTostr(i + 1) + '            ' + floatTostr(y[i]));
  end;
  j := 0;
  for i := 0 to Nl - 1 do begin
    if abs(b[i]) > allowable_errorr then aer := y[i] / b[i]
                                    else aer := y[i];
    if abs(aer) > allowable_errorr then inc(j);
  end;
  if checkbox1.Checked = false then begin
    if j = 0 then memo1.Lines.Append('   OK')
             else memo1.Lines.Append('   NG');
    if j > 0 then exit;
  end;
  for i := 0 to Nl - 1 do memo1.Lines.Append('x' + intTostr(i + 1) + '= ' + floatTostr(x[i]));
end;

// ObhTCY̕ύX
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  ch: integer;
begin
  val(LabeledEdit1.Text, Nl, ch);
  if ch <> 0 then begin
    MessageDlg('N̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  GridSet(Nl, Nl);
end;

// eXgf[^[̑Iݒ
procedure TForm1.testset;
var
  i, j : integer;
begin
  GridSet(Nltest, Nltest);
  Nl := Nltest;
  for i := 1 to Nltest do
    for j := 1 to Nltest do begin
      case RadioGroup1.ItemIndex of
        0: StringGrid1.Cells[i,j] := floatTostr(mattestA[j-1, i-1]);
        1: StringGrid1.Cells[i,j] := floatTostr(mattestB[j-1, i-1]);
        2: StringGrid1.Cells[i,j] := floatTostr(mattestC[j-1, i-1]);
        3: StringGrid1.Cells[i,j] := floatTostr(mattestD[j-1, i-1]);
        4: StringGrid1.Cells[i,j] := floatTostr(mattestE[j-1, i-1]);
      end;
    end;
  for i := 1 to Nltest do begin
    case RadioGroup1.ItemIndex of
      0: StringGrid2.Cells[1,i]  := floatTostr(btestA[i-1]);
      1,2,3,4: StringGrid2.Cells[1,i]  := floatTostr(btestB[i-1]);
    end;
  end;
  LabeledEdit1.Text := intTostr(Nltest);
  memo1.Clear;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  testset;
end;

// l̐ݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  a : extended;
begin
  testset;
  epsilon := 1;
  repeat
    epsilon := epsilon / 2;
    a := 1 - epsilon;
  until a = 1;
  epsilon := epsilon * 2;
end;

end.
